Index: t3lib/class.t3lib_tceforms.php
===================================================================
--- t3lib/class.t3lib_tceforms.php	(Revision 2398)
+++ t3lib/class.t3lib_tceforms.php	(Arbeitskopie)
@@ -285,7 +285,7 @@
 	var $requiredElements=array();				// Used to register the min and max number of elements for selectorboxes where that apply (in the "group" type for instance)
 	var $renderDepth=0;							// Keeps track of the rendering depth of nested records.
 	var $savedSchemes=array();					// Color scheme buffer.
-	var $dynTabLevelStack = array();			// holds tab dividers which were cascaded, required for RTE&IRRE
+	var $dynNestedStack = array();				// holds the path an element is nested in (e.g. required for RTEhtmlarea)
 
 		// Internal, registers for user defined functions etc.
 	var $additionalCode_pre = array();			// Additional HTML code, printed before the form.
@@ -493,13 +493,6 @@
 			if ($TCA[$table]['types'][$typeNum])	{
 				$itemList = $TCA[$table]['types'][$typeNum]['showitem'];
 				if ($itemList)	{	// If such a list existed...
-						// if TCEforms will render a tab menu in the next step, push the name to the tab stack
-					if (strstr($itemList, '--div--') !== false && $this->enableTabMenu && $TCA[$table]['ctrl']['dividers2tabs']) {
-						$tabIdentString = 'TCEforms:'.$table.':'.$row['uid'];
-						$tabIdentStringMD5 = $GLOBALS['TBE_TEMPLATE']->getDynTabMenuId('TCEforms:'.$table.':'.$row['uid']);
-						$this->dynTabLevelStack[$tabIdentStringMD5] = 1;
-					}
-
 						// Explode the field list and possibly rearrange the order of the fields, if configured for
 					$fields = t3lib_div::trimExplode(',',$itemList,1);
 					if ($this->fieldOrder)	{
@@ -510,6 +503,16 @@
 					$excludeElements = $this->excludeElements = $this->getExcludeElements($table,$row,$typeNum);
 					$fields = $this->mergeFieldsWithAddedFields($fields,$this->getFieldsToAdd($table,$row,$typeNum));
 
+						// If TCEforms will render a tab menu in the next step, push the name to the tab stack:
+					if (strstr($itemList, '--div--') !== false && $this->enableTabMenu && $TCA[$table]['ctrl']['dividers2tabs']) {
+						$tabIdentString = 'TCEforms:'.$table.':'.$row['uid'];
+						$tabIdentStringMD5 = $GLOBALS['TBE_TEMPLATE']->getDynTabMenuId('TCEforms:'.$table.':'.$row['uid']);
+							// Remember that were currently working on the general tab:
+						if (isset($fields[0]) && strpos($fields[0], '--div--') !== 0) {
+							$this->pushToDynNestedStack('tab', $tabIdentStringMD5.'-1');
+						}
+					}
+
 						// Traverse the fields to render:
 					$cc=0;
 					foreach($fields as $fieldInfo)	{
@@ -551,14 +554,21 @@
 
 									if ($this->enableTabMenu && $TCA[$table]['ctrl']['dividers2tabs'])	{
 										$this->wrapBorder($out_array[$out_sheet],$out_pointer);
+											// Remove last tab entry from the dynNestedStack:
 										$out_sheet++;
-											// remember what sheet we're currently in
-										$this->dynTabLevelStack[$tabIdentStringMD5] = $out_sheet+1;
+											// Remove the previous sheet from stack (if any):
+										$this->popFromDynNestedStack('tab', $tabIdentStringMD5.'-'.($out_sheet));
+											// Remember on which sheet we're currently working:
+										$this->pushToDynNestedStack('tab', $tabIdentStringMD5.'-'.($out_sheet+1));
 										$out_array[$out_sheet] = array();
 										$out_array_meta[$out_sheet]['title'] = $this->sL($parts[1]);
 									}
 								} else {	// Setting alternative title for "General" tab if "--div--" is the very first element.
 									$out_array_meta[$out_sheet]['title'] = $this->sL($parts[1]);
+										// Only add the first tab to the dynNestedStack if there are more tabs:
+									if (strpos($itemList, '--div--', strlen($fieldInfo))) {
+										$this->pushToDynNestedStack('tab', $tabIdentStringMD5.'-1');
+									}
 								}
 							} elseif($theField=='--palette--')	{
 								if ($parts[2] && !isset($this->palettesRendered[$this->renderDepth][$table][$parts[2]]))	{
@@ -627,8 +637,8 @@
 				);
 			}
 
-				// unset the current level of tab menus
-			unset($this->dynTabLevelStack[$tabIdentStringMD5]);
+				// Unset the current level of tab menus:
+			$this->popFromDynNestedStack('tab', $tabIdentStringMD5.'-'.($out_sheet+1));
 
 			return '
 				<tr>
@@ -5428,19 +5438,52 @@
 	}
 	
 	/**
-	 * Get a list, depending on $this->dynTabLevelStack, that has the information
-	 * in which tab (--div--) fields are inserted.
+	 * Push a new element to the dynNestedStack. Thus, every object know, if it's
+	 * nested in a tab or IRRE level and in which order this was processed.
 	 *
-	 * @param	string		$appendString: String to append for each item
-	 * @return	string		A list of cascaded tab divs, like "DTM-2e8791854a-1,DTM-f3c79a0523-4"
+	 * @param	string		$type: Type of the level, e.g. "tab" or "inline"
+	 * @param	string		$ident: Identifier of the level
+	 * @return	void
 	 */
-	function getDynTabLevelState($appendString = '') {
-		$levels = array();
-		foreach ($this->dynTabLevelStack as $tabIdent => $divId) {
-			$levels[] = $tabIdent.'-'.$divId.$appendString;
+	function pushToDynNestedStack($type, $ident) {
+		$this->dynNestedStack[] = array($type, $ident);
+	}
+
+	/**
+	 * Remove an element from the dynNestedStack. If $type and $ident
+	 * are set, the last element will only be removed, if it matches
+	 * what is expected to be removed.
+	 * 
+	 * @param	string		$type: Type of the level, e.g. "tab" or "inline"
+	 * @param	string		$ident: Identifier of the level
+	 * @return	void
+	 */
+	function popFromDynNestedStack($type=null, $ident=null) {
+		if ($type!=null && $ident!=null) {
+			$last = end($this->dynNestedStack);
+			if ($type==$last[0] && $ident==$last[1]) {
+				array_pop($this->dynNestedStack);
+			}
+		} else {
+			array_pop($this->dynNestedStack);
 		}
-		return implode(',', $levels);
 	}
+
+	/**
+	 * Get the dynNestedStack as associative array.
+	 * The result is e.g. ['tab','DTM-ABCD-1'], ['inline','data[13][table][uid][field]'], ['tab','DTM-DEFG-2'], ...
+	 *
+	 * @param	boolean		$json: Return a JSON string instead of an array - default: false
+	 * @param	boolean		$skipFirst: Skip the first element in the dynNestedStack - default: false
+	 * @return	mixed		Returns an associative array by default. If $json is true, it will be returned as JSON string.
+	 */
+	function getDynNestedStack($json=false, $skipFirst=false) {
+		$result = $this->dynNestedStack;
+		if ($skipFirst) {
+			array_shift($result);
+		}
+		return ($json ? $this->inline->getJSON($result) : $result);
+	}
 }
 
 
Index: t3lib/jsfunc.inline.js
===================================================================
--- t3lib/jsfunc.inline.js	(Revision 2398)
+++ t3lib/jsfunc.inline.js	(Arbeitskopie)
@@ -1,32 +1,30 @@
 /*<![CDATA[*/
 
 /***************************************************************
-*  Inline-Relational-Record Editing
+* Inline-Relational-Record Editing
 *
 * $Id$
 *
+* Copyright notice
 *
+* (c) 2006 Oliver Hader <oh@inpublica.de>
+* All rights reserved
 *
-*  Copyright notice
+* This script is part of the TYPO3 project. The TYPO3 project is
+* free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
 *
-*  (c) 2006 Oliver Hader <oh@inpublica.de>
-*  All rights reserved
+* The GNU General Public License can be found at
+* http://www.gnu.org/copyleft/gpl.html.
 *
-*  This script is part of the TYPO3 project. The TYPO3 project is
-*  free software; you can redistribute it and/or modify
-*  it under the terms of the GNU General Public License as published by
-*  the Free Software Foundation; either version 2 of the License, or
-*  (at your option) any later version.
+* This script is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
 *
-*  The GNU General Public License can be found at
-*  http://www.gnu.org/copyleft/gpl.html.
-*
-*  This script is distributed in the hope that it will be useful,
-*  but WITHOUT ANY WARRANTY; without even the implied warranty of
-*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*  GNU General Public License for more details.
-*
-*  This copyright notice MUST APPEAR in all copies of the script!
+* This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
 
 var inline = {
@@ -97,38 +95,61 @@
 	},
 
 	createNewRecord: function(objectId,prevRecordUid) {
-		if (this.isBelowMax(objectId)) this.makeAjaxCall('createNewRecord', objectId+(prevRecordUid ? '['+prevRecordUid+']' : ''));
-		else alert('There are no more relations possible at this moment!');
+		if (this.isBelowMax(objectId)) {
+			if (prevRecordUid) {
+				objectId += '['+prevRecordUid+']';
+			}
+			this.makeAjaxCall('createNewRecord', [this.getNumberOfRTE(), objectId], true);
+		} else {
+			alert('There are no more relations possible at this moment!');
+		}
 		return false;
 	},
 
 	setExpandedCollapsedState: function(objectId, expand, collapse) {
-		this.makeAjaxCall('setExpandedCollapsedState', objectId, expand, collapse);
+		this.makeAjaxCall('setExpandedCollapsedState', [objectId, expand, collapse]);
 	},
 
-	makeAjaxCall: function() {
-		if (arguments.length > 1) {
-			var params = '';
-			for (var i=0; i<arguments.length; i++) params += '&ajax['+i+']='+arguments[i];
-
-			var url = 'alt_doc_ajax.php';
-			var options = {
+	makeAjaxCall: function(method, params, lock) {
+		var max, url='', urlParams='', options={};
+		if (method && params && params.length && this.lockAjaxMethod(method, lock)) {
+			url = 'alt_doc_ajax.php';
+			urlParams += '&ajax[0]='+method;
+			for (var i=0, max=params.length; i<max; i++) {
+				urlParams += '&ajax['+(i+1)+']='+params[i];
+			}
+			options = {
 				method:		'post',
-				parameters:	params,
-				onSuccess:	inline.processAjaxResponse,
-				onFailure:	inline.showAjaxFailure
+				parameters:	urlParams,
+				onSuccess:	function(xhr) { inline.processAjaxResponse(method, xhr); },
+				onFailure:	function(xhr) { inline.showAjaxFailure(method, xhr); }
 			};
 
 			new Ajax.Request(url, options);
 		}
 	},
 
-	processAjaxResponse: function(xhr) {
+	lockAjaxMethod: function(method, lock) {
+		if (!lock || !inline.lockedAjaxMethod[method]) {
+			inline.lockedAjaxMethod[method] = true;
+			return true;
+		} else {
+			return false;
+		}
+	},
+
+	unlockAjaxMethod: function(method) {
+		inline.lockedAjaxMethod[method] = false;
+	},
+
+	processAjaxResponse: function(method, xhr) {
+		inline.unlockAjaxMethod(method);
 		var json = eval('('+xhr.responseText+')');
 		for (var i in json.scriptCall) eval(json.scriptCall[i]);
 	},
 
-	showAjaxFailure: function(xhr) {
+	showAjaxFailure: function(method, xhr) {
+		inline.unlockAjaxMethod(method);
 		alert('Error: '+xhr.status+"\n"+xhr.statusText);
 	},
 
@@ -140,7 +161,7 @@
 			if (!this.data.unique || !this.data.unique[objectId]) {
 				selector.options[selector.selectedIndex].selected = false;
 			}
-			this.makeAjaxCall('createNewRecord', objectId, selectedValue);
+			this.makeAjaxCall('createNewRecord', [this.getNumberOfRTE(), objectId, selectedValue], true);
 		}
 		return false;
 	},
@@ -149,7 +170,7 @@
 	importElement: function(objectId, table, uid, type) {
 		window.setTimeout(
 			function() {
-				inline.makeAjaxCall('createNewRecord', objectId, uid);
+				inline.makeAjaxCall('createNewRecord', [this.getNumberOfRTE(), objectId, uid], true);
 			},
 			10
 		);
@@ -173,7 +194,7 @@
 				// for select: only the uid is stored
 			if (unique['type'] == 'select') {
 				if (values.indexOf(uid) != -1) return true;
-				
+
 				// for group/db: table and uid is stored in a assoc array
 			} else if (unique.type == 'groupdb') {
 				for (var i=values.length-1; i>=0; i--) {
@@ -291,7 +312,7 @@
 			var checked = new Array();
 			var order = Sortable.sequence(element);
 			var records = formObj[0].value.split(',');
-			
+
 				// check if ordered uid is really part of the records
 				// virtually deleted items might still be there but ordering shouldn't saved at all on them
 			for (var i=0; i<order.length; i++) {
@@ -443,7 +464,7 @@
 		if (unique.type == 'select') {
 			if (fieldObj && fieldObj.length) {
 				delete(this.data.unique[objectPrefix].used[recordUid])
-				
+
 				if (unique.selector == 'select') {
 					if (!isNaN(fieldObj[0].value)) {
 						var selector = $(objectPrefix+'_selector');
@@ -689,6 +710,26 @@
 		return $(objectId+'_div') && $(objectId+'_div').hasClassName('inlineIsNewRecord')
 			? true
 			: false;
+	},
+
+		// Find and fix nested of inline and tab levels if a new element was created dynamically (it doesn't know about its nesting):
+	findContinuedNestedLevel: function(nested, objectId) {
+		if (this.data.nested && this.data.nested[objectId]) {
+				// Remove the first element from the new nested stack, it's just a hint:
+			nested.shift();
+			nested = this.data.nested[objectId].concat(nested);
+			return nested;
+		} else {
+			return nested;
+		}
+	},
+
+	getNumberOfRTE: function() {
+		var number = 0;
+		if (typeof RTEarea != 'undefined' && RTEarea.length > 0) {
+			number = RTEarea.length-1;
+		}
+		return number;
 	}
 }
 
Index: t3lib/class.t3lib_tceforms_inline.php
===================================================================
--- t3lib/class.t3lib_tceforms_inline.php	(Revision 2398)
+++ t3lib/class.t3lib_tceforms_inline.php	(Arbeitskopie)
@@ -91,6 +91,7 @@
 	var $fObj;								// Reference to the calling TCEforms instance
 	var $backPath;							// Reference to $fObj->backPath
 
+	var $isAjaxCall = false;				// Indicates if a field is rendered upon an AJAX call
 	var $inlineStructure = array();			// the structure/hierarchy where working in, e.g. cascading inline tables
 	var $inlineFirstPid;					// the first call of an inline type appeared on this page (pid of record)
 	var $inlineNames = array();				// keys: form, object -> hold the name/id for each of them
@@ -178,7 +179,7 @@
 		$config['inline']['first'] = $recordList[0]['uid'];
 		$config['inline']['last'] = $recordList[count($recordList)-1]['uid'];
 
-			// tell the browser what we have (using JSON later)
+			// Tell the browser what we have (using JSON later):
 		$top = $this->getStructureLevel(0);
 		$this->inlineData['config'][$nameObject] = array('table' => $foreign_table);
 		$this->inlineData['config'][$nameObject.'['.$foreign_table.']'] = array(
@@ -190,6 +191,8 @@
 				'uid'	=> $top['uid'],
 			),
 		);
+			// Set a hint for nested IRRE and tab elements:
+		$this->inlineData['nested'][$nameObject] = $this->fObj->getDynNestedStack(false, $this->isAjaxCall);
 
 			// if relations are required to be unique, get the uids that have already been used on the foreign side of the relation
 		if ($config['foreign_unique']) {
@@ -308,6 +311,8 @@
 		$nameObject = $this->inlineNames['object'];
 		$appendFormFieldNames = '['.$foreign_table.']['.$rec['uid'].']';
 		$formFieldNames = $nameObject.$appendFormFieldNames;
+			// Put the current level also to the dynNestedStack of TCEforms:
+		$this->fObj->pushToDynNestedStack('inline', $this->inlineNames['object'].$appendFormFieldNames);
 
 		$header = $this->renderForeignRecordHeader($parentUid, $foreign_table, $rec, $config);
 		$combination = $this->renderCombinationTable($rec, $appendFormFieldNames, $config);
@@ -340,6 +345,9 @@
 			// wrap the header, fields and combination part of a child record with a div container
 		$out = '<div id="'.$formFieldNames.'_div"'.($isNewRecord ? ' class="inlineIsNewRecord"' : '').'>' . $out . '</div>';
 
+			// Remove the current level also from the dynNestedStack of TCEforms:
+		$this->fObj->popFromDynNestedStack();
+
 		return $out;
 	}
 
@@ -773,6 +781,21 @@
 
 
 	/**
+	 * Initialize environment for AJAX calls
+	 *
+	 * @param	string		$method: Name of the method to be called
+	 * @param	array		$arguments: Arguments to be delivered to the method
+	 * @return	void
+	 */
+	function initForAJAX($method, &$arguments) {
+			// Set t3lib_TCEforms::$RTEcounter to the given value:
+		if ($method == 'createNewRecord') {
+			$this->fObj->RTEcounter = intval(array_shift($arguments));
+		}
+	}
+
+
+	/**
 	 * Handle AJAX calls to show a new inline-record of the given table.
 	 * Normally this method is never called from inside TYPO3. Always from outside by AJAX.
 	 *
@@ -781,6 +804,7 @@
 	 * @return	string		A JSON string
 	 */
 	function createNewRecord($domObjectId, $foreignUid = 0) {
+		$this->isAjaxCall = true;
 			// parse the DOM identifier (string), add the levels to the structure stack (array) and load the TCA config
 		$this->parseStructureString($domObjectId, true);
 			// the current table - for this table we should add/import records
@@ -789,7 +813,10 @@
 		$parent = $this->getStructureLevel(-1);
 			// get TCA 'config' of the parent table
 		$config = $parent['config'];
-		
+
+			// Put the current level also to the dynNestedStack of TCEforms:
+		$this->fObj->pushToDynNestedStack('inline', $this->inlineNames['object']);
+
 			// dynamically create a new record using t3lib_transferData
 		if (!$foreignUid || !t3lib_div::testInt($foreignUid) || $config['foreign_selector']) {
 			$record = $this->getNewRecord($this->inlineFirstPid, $current['table']);
@@ -861,6 +888,9 @@
 			// fade out and fade in the new record in the browser view to catch the user's eye
 		$jsonArray['scriptCall'][] = "inline.fadeOutFadeIn('".$objectId."_div');";
 
+			// Remove the current level also from the dynNestedStack of TCEforms:
+		$this->fObj->popFromDynNestedStack();
+
 			// return the JSON string
 		return $this->getJSON($jsonArray);
 	}
@@ -1732,7 +1762,7 @@
 	 * @return	integer		A pixel value for the margin of each new inline level.
 	 */
 	function getLevelMargin() {
-		$margin = $this->inlineStyles['margin-right'];
+		$margin = ($this->inlineStyles['margin-right']+1)*2;
 		return $margin;
 	}
  }
Index: typo3/alt_doc_ajax.php
===================================================================
--- typo3/alt_doc_ajax.php	(Revision 2398)
+++ typo3/alt_doc_ajax.php	(Arbeitskopie)
@@ -131,8 +131,12 @@
 			$method = array_shift($this->ajax);
 
 				// Security check
-			if(!in_array($method, array('createNewRecord', 'setExpandedCollapsedState'))) return false;
+			if (!in_array($method, array('createNewRecord', 'setExpandedCollapsedState'))) {
+				return false;
+			}
 
+				// Perform the requested action:
+			$this->tceforms->inline->initForAJAX($method, $this->ajax);
 			$this->content = call_user_func_array(
 				array(&$this->tceforms->inline, $method),
 				$this->ajax
Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js	(Revision 2398)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js	(Arbeitskopie)
@@ -43,25 +43,23 @@
 HTMLArea.prototype._initEditMode = function () {
 		// We can't set designMode when we are in a hidden TYPO3 tab
 		// Then we will set it when the tab comes in the front.
-	var inTYPO3Tab = false;
-	var DTMDiv = this._textArea;
-	while (DTMDiv && (DTMDiv.nodeType == 1) && (DTMDiv.tagName.toLowerCase() != "body")) {
-		if (DTMDiv.tagName.toLowerCase() == "div" && DTMDiv.id.indexOf("DTM-") != -1 && DTMDiv.id.indexOf("-DIV") != -1 && DTMDiv.className == "c-tablayer") {
-			inTYPO3Tab = true;
-			break;
-		} else {
-			DTMDiv = DTMDiv.parentNode;
-		}
+	var isNested = false;
+	var allDisplayed = true;
+
+	if (this.nested.sorted && this.nested.sorted.length) {
+		isNested = true;
+		allDisplayed = HTMLArea.allElementsAreDisplayed(this.nested.sorted);
 	}
+
 	if (!HTMLArea.is_wamcom) {
 		try {
-			if (!(inTYPO3Tab && DTMDiv.style.display == "none")) this._doc.designMode = "on";
+			if (!isNested || allDisplayed) this._doc.designMode = "on";
 		} catch(e) { }
 	} else {
 		try { 
 			this._doc.designMode = "on"; 
 		} catch(e) {
-			if (!(inTYPO3Tab && DTMDiv.style.display == "none")) {
+			if (!isNested || allDisplayed) {
 				this._doc.open();
 				this._doc.close();
 				this._initIframeTimer = window.setTimeout("HTMLArea.initIframe(" + this._editorNumber + ");", 500);
@@ -72,7 +70,15 @@
 		// When the TYPO3 TCA feature div2tab is used, the editor iframe may become hidden with style.display = "none"
 		// This breaks the editor in Mozilla/Firefox browsers: the designMode attribute needs to be resetted after the style.display of the containing div is resetted to "block"
 		// Here we rely on TYPO3 naming conventions for the div id and class name
-	if (inTYPO3Tab) HTMLArea._addEvent(DTMDiv, "DOMAttrModified", HTMLArea.DTMDivHandler(this, DTMDiv));
+	if (this.nested.sorted && this.nested.sorted.length) {
+		var nestedObj, listenerFunction;
+		for (var i=0, length=this.nested.sorted.length; i < length; i++) {
+			nestedObj = document.getElementById(this.nested.sorted[i]);
+			listenerFunction = HTMLArea.NestedListener(this, nestedObj, false);
+			HTMLArea._addEvent(nestedObj, 'DOMAttrModified', listenerFunction);
+		}
+	}
+
 	return true;
 };
 
@@ -282,26 +288,44 @@
  ***************************************************/
 
 /*
- * TYPO3 hidden tab handler
+ * TYPO3 hidden tab and inline event listener (gets event calls)
  */
-HTMLArea.DTMDivHandler = function (editor,DTMDiv) {
+HTMLArea.NestedListener = function (editor,nestedObj,noOpenCloseAction) {
 	return (function(ev) {
 		if(!ev) var ev = window.event;
+		HTMLArea.NestedHandler(ev,editor,nestedObj,noOpenCloseAction);
+	});
+};
+
+/*
+ * TYPO3 hidden tab and inline event handler (performs actions on event calls)
+ */
+HTMLArea.NestedHandler = function(ev,editor,nestedObj,noOpenCloseAction) {
+	window.setTimeout(function() {
 		var target = (ev.target) ? ev.target : ev.srcElement;
-		if(target == DTMDiv && editor._editMode == "wysiwyg" && DTMDiv.style.display == "block") {
-			window.setTimeout( function() {
-				try { 
-					editor._doc.designMode = "on";
-					if (editor.config.sizeIncludesToolbar && editor._initialToolbarOffsetHeight != editor._toolbar.offsetHeight) editor.sizeIframe(-2);
-				} catch(e) {
-					editor._doc.open();
-					editor._doc.close();
-					editor.initIframe();
-				}
-			}, 20);
+		if(target == nestedObj && editor._editMode == "wysiwyg" && ev.attrName=='style' && (target.style.display == '' || target.style.display == 'block')) {
+				// Check if all affected nested elements are displayed (style.display!='none'):
+			if (HTMLArea.allElementsAreDisplayed(editor.nested.sorted)) {
+				window.setTimeout(function() {
+					try { 
+						editor._doc.designMode = "on";
+						if (editor.config.sizeIncludesToolbar && editor._initialToolbarOffsetHeight != editor._toolbar.offsetHeight) {
+							editor.sizeIframe(-2);
+						}
+					} catch(e) {
+							// If an event of a parent tab ("nested tabs") is triggered, the following lines should not be
+							// processed, because this causes some trouble on all event handlers...
+						if (!noOpenCloseAction) {
+							editor._doc.open();
+							editor._doc.close();
+						}
+						editor.initIframe();
+					}
+				}, 50);
+			}
 			HTMLArea._stopEvent(ev);
 		}
-	});
+	}, 50);
 };
 
 /*
@@ -538,7 +562,7 @@
 			editor._unLink = null;
 			editor._unlinkOnUndo = false;
 		};
-		
+
 		editor._unlinkOnUndo = true;
 		return a;
 	};
